<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['系统']['管理模块'] = $filename;
	return;
}

define('IN_PHPBB', true);
define('ROOT_PATH', './../');

require('./pagestart.php');

require(ROOT_PATH . 'includes/class/admin_module.php');

require('page_header_admin.php');

$mode = get_var('mode', '');

switch($mode)
{	
	case 'insert':
	
		$module_id = get_var('mid', '');
		
		if ( isset($_POST['submit']) && isset($_POST['module_text']) )
		{
			$module_text = get_var('module_text', '');
			
			if ( $admin_module->update_insert_content($module_id, $module_text) )
			{
				message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href=' . append_sid('admin_modules.php?mode=manage') . '>这里</a> 返回页面编辑模式页');
			}
		}
		else
		{
			if ( empty($module_id) )
			{
				message_die(GENERAL_MESSAGE, '请指定要编辑的模块');
			}
		
			$admin_module->insert_content($module_id);
		}
	break;
	
	case 'create':
		if (isset($_POST['submit']))
		{	
			$module_name	= get_var('name', '');
			$module_param	= get_var('module_param', '');
			$module_type	= get_var('type', MODULE_COMMON);
			
			$module_order	= get_var('order', 0);
			$module_br		= ( isset($_POST['br']) ) ? 1 : 0;
			$module_show	= ( isset($_POST['show']) ) ? 1 : 0;
			
			if ( !$admin_module->validate_type($module_type, $module_param, $module_name) )
			{
				message_die(GENERAL_MESSAGE, '请输入正确的模块参数');
			}
			
			if ( !$admin_module->insert_module_data($global_style, '', $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, true) )
			{
				message_die(GENERAL_ERROR, '模块sql无法插入到数据库中', '', __LINE__, __FILE__);
			}
			
			message_die(GENERAL_MESSAGE, '创建成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->module(false);
		}
		
	break;
	
	case 'edit':
		
		$module_id = get_var('mid', 0);
		
		if (!$module_id)
		{
			message_die(GENERAL_MESSAGE, '请指定要编辑的模块');
		}
		
		if (isset($_POST['submit']))
		{
			if(isset($_POST['delete']))
			{	
				$module_id = abs(intval($module_id));
				
				if ( !$admin_module->delete($module_id) )
				{
					message_die(GENERAL_MESSAGE, '您指定了一个不存在的模块');
				}
				
				message_die(GENERAL_MESSAGE, '模块（ID:' . $module_id . '）已成功删除！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
			}
			
			$module_name	= get_var('name', '');
			$module_param	= get_var('module_param', '');
			$module_type	= get_var('type', MODULE_COMMON);
			$module_order	= get_var('order', 0);
			$module_br		= ( isset($_POST['br']) ) ? 1 : 0;
			$module_show	= ( isset($_POST['show']) ) ? 1 : 0;
			
			if ( !$admin_module->validate_type($module_type, $module_param, $module_name) )
			{
				message_die(GENERAL_MESSAGE, '请输入正确的MODS路径、或模块名称');
			}
			
			if ( !$admin_module->insert_module_data($global_style, $module_id, $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, false) )
			{
				message_die(GENERAL_ERROR, '模块sql无法插入到数据库中', '', __LINE__, __FILE__);
			}
			
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->module(true, $module_id);
		}
	break;
	
	case 'desc':
		if (isset($_POST['site_desc']))
		{
			$desc = get_var('site_desc', '');
			$admin_module->update_desc($desc);
			$cache->remove_file('global_config');
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->desc_content();
		}
	break;
	
	case 'top':
		if (isset($_POST['other_module']))
		{
			$top_module = get_var('other_module', '');
			$admin_module->update_other_module_data($global_style, MODULE_TOP, $top_module);
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->other_module($global_style, MODULE_TOP);
		}
	break;
	
	case 'bottom':
		if (isset($_POST['other_module']))
		{
			$bottom_module = get_var('other_module', '');
			$admin_module->update_other_module_data($global_style, MODULE_BOTTOM, $bottom_module);
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->other_module($global_style, MODULE_BOTTOM);
		}
	break;
	
	case 'head':
		if (isset($_POST['other_module']))
		{
			$head_module = get_var('other_module', '');
			$admin_module->update_other_module_data($global_style, MODULE_HEAD, $head_module);
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->other_module($global_style, MODULE_HEAD);
		}
	break;

	case 'foot':
		if (isset($_POST['other_module']))
		{
			$foot_module = get_var('other_module', '');
			$admin_module->update_other_module_data($global_style, MODULE_FOOT, $foot_module);
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_module->other_module($global_style, MODULE_FOOT);
		}
	break;
	
	case 'logo':
	
		$submit = isset($_POST['submit']) ? true :false;
		if( $submit )
		{
			if ( (($_FILES['logo']['type'] == 'image/png') || ($_FILES['logo']['type'] == 'image/gif') || ($_FILES['logo']['type'] == 'image/jpeg') || ($_FILES['logo']['type'] == 'image/jpg') || ($_FILES['logo']['type'] == 'image/pjpeg')) && ($_FILES['logo']['size'] < 2097152) )
			{
				if ($_FILES['logo']['error'] > 0)
				{
					message_die(GENERAL_ERROR, '文件上传出错：' . $_FILES['logo']['error'], '', __LINE__, __FILE__);
				}
				else
				{
					if ($_FILES['logo']['type'] == 'image/png')
					{
						$logo_name = 'logo.png';
					}
					else if($_FILES['logo']['type'] == 'image/gif')
					{
						$logo_name = 'logo.gif';
					}
					else if($_FILES['logo']['type'] == 'image/jpeg' || $_FILES['logo']['type'] == 'image/jpg' || $_FILES['logo']['type'] == 'image/pjpeg')
					{
						$logo_name = 'logo.jpg';
					}
					else
					{
						$logo_name = 'logo.jpg';
					}
					
					move_uploaded_file($_FILES['logo']['tmp_name'], '../images/' . $logo_name);
					
					$sql = "UPDATE " . CONFIG_TABLE . " 
						SET config_value =  '$logo_name' 
						WHERE  config_name = 'site_logo'";
					if ( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, '无法更新 config 表', '', __LINE__, __FILE__, $sql);
					}
					
					$cache->remove_file('global_config');
					
					message_die(GENERAL_MESSAGE, 'Logo修改成功！<br />点击 <a href="' . append_sid('admin_modules.php') . '">这里</a> 返回页面编辑模式');
				}
			}
			else
			{
				message_die(GENERAL_MESSAGE, '请检查图片类型和大小是否正确！');
			}
		}
		else
		{
			$admin_module->logo();
		}
	
	break;
	default:
		$admin_module->show_manage($global_style);
}

$template->pparse('body');
require('page_footer_admin.php');
?>