<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['系统']['自定义页面'] = $filename;
	return;
}

define('IN_PHPBB', true);
define('ROOT_PATH', './../');

require('./pagestart.php');
require(ROOT_PATH . 'includes/class/page_module.php');
require(ROOT_PATH . 'includes/class/admin_page.php');

require('page_header_admin.php');

$mode 		= get_var('mode', '');

function get_page_info($page_id)
{
	global $db;

	$sql = 'SELECT page_id, page_title 
		FROM ' . PAGES_TABLE . ' 
		WHERE page_id = ' . $page_id;

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, '无法查询 ' . PAGES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
	}

	if (!$db->sql_numrows($result))
	{
		message_die(GENERAL_MESSAGE, '页面不存在', '404');
	}

	return $db->sql_fetchrow($result);
}


$admin_page = new admin_page;

switch ($mode)
{
	// 【插】功能
	case 'insert':
		$page_id 	= get_var('page_id', 0);
		$module_id	= get_var('mid', 0);

		if ( empty($module_id) || empty($page_id) )
		{
			message_die(GENERAL_MESSAGE, '请指定要编辑的模块');
		}

		if ( isset($_POST['submit']) && isset($_POST['module_text']))
		{
			$module_text = get_var('module_text', '');
			
			if ( $admin_page->update_insert_content($page_id, $module_id, $module_text) )
			{
				message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href=' . append_sid('admin_pages.php?mode=manage&amp;page_id=' . $page_id) . '>这里</a> 返回页面编辑模式页');
			}
		}
		else
		{
			$admin_page->insert_content($page_id, $module_id);
		}
		break;
	// 创建页面
	case 'create':
		$page_id 		= get_var('page_id', 0);
		if (isset($_POST['submit']))
		{

			$module_name	= get_var('name', '');
			$module_param	= get_var('module_param', '');
			$module_type	= get_var('type', MODULE_COMMON);
			
			$module_order	= get_var('order', 0);
			$module_br		= ( isset($_POST['br']) ) ? 1 : 0;
			$module_show	= ( isset($_POST['show']) ) ? 1 : 0;
			
			if ( !$admin_page->validate_type($module_type, $module_param, $module_name) )
			{
				message_die(GENERAL_MESSAGE, '请输入正确的模块参数');
			}
			
			if ( !$admin_page->insert_module_data($page_id, '', $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, true) )
			{
				message_die(GENERAL_ERROR, '模块sql无法插入到数据库中', '', __LINE__, __FILE__);
			}
			
			message_die(GENERAL_MESSAGE, '创建成功！<br />点击 <a href="' . append_sid('admin_pages.php?mode=manage&amp;page_id=' . $page_id) . '">这里</a> 返回页面编辑模式');
		}
		else
		{
			$admin_page->module($page_id, false);
		}
		break;
	// 修改页面
	case 'edit':
		$module_id 	= get_var('mid', 0);
		$page_id 	= get_var('page_id', 0);

		if (!$module_id || !$page_id) 
		{
			message_die(GENERAL_MESSAGE, '请指定要编辑的模块');
		}

		if (isset($_POST['submit']))
		{
			if(isset($_POST['delete']))
			{	
				$module_id = abs(intval($module_id));
				
				if ( !$admin_page->delete($module_id) )
				{
					message_die(GENERAL_MESSAGE, '您指定了一个不存在的模块');
				}
				
				message_die(GENERAL_MESSAGE, '模块（ID:' . $module_id . '）已成功删除！<br />点击 <a href="' . append_sid('admin_pages.php?mode=manage&amp;page_id=' . $page_id) . '">这里</a> 返回页面编辑模式');
			}
			
			$module_name	= get_var('name', '');
			$module_param	= get_var('module_param', '');
			$module_type	= get_var('type', MODULE_COMMON);
			$module_order	= get_var('order', 0);
			$module_br		= ( isset($_POST['br']) ) ? 1 : 0;
			$module_show	= ( isset($_POST['show']) ) ? 1 : 0;
			
			if ( !$admin_page->validate_type($module_type, $module_param, $module_name) )
			{
				message_die(GENERAL_MESSAGE, '请输入正确的参数');
			}
			
			if ( !$admin_page->insert_module_data($page_id, $module_id, $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, false) )
			{
				message_die(GENERAL_ERROR, '模块sql无法插入到数据库中', '', __LINE__, __FILE__);
			}
			
			message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_pages.php?mode=manage&amp;page_id=' . $page_id) . '">这里</a> 返回上级页面');
		}
		else
		{
			$admin_page->module(true, $page_id, $module_id);
		}
		break;
	case 'manage':
		$page_id 	= get_var('page_id', 0);
		$pages 		= get_page_info($page_id); 
		$admin_page->manage($pages['page_id']);
		break;
	// 页面列表
	default:
		$action = get_var('action', '');
		if ($action == 'create')
		{
			if (isset($_POST['page_title']))
			{
				$page_title = get_var('page_title', '');

				if ($admin_page->admin_edit_page_update(false, '', $page_title))
				{
					message_die(GENERAL_MESSAGE, '保存成功！<br />点击 <a href="' . append_sid('admin_pages.php') . '">这里</a> 返回自定义页面列表');
				}

			}
			$admin_page->admin_edit_page_body(false);
		}
		else if ($action == 'edit')
		{
			$page_id = get_var('page_id', 0);
			if (!$page_id)
			{
				message_die(GENERAL_MESSAGE, '请指定要编辑的页面', '提示');
			}

			if (isset($_POST['delete']))
			{
				if ($admin_page->admin_delete_page($page_id))
				{
					message_die(GENERAL_MESSAGE, '页面（ID:' . $page_id . '）已成功删除！<br />点击 <a href="' . append_sid('admin_pages.php') . '">这里</a> 返回自定义页面列表');
				}
			}

			if (isset($_POST['page_title']))
			{
				$page_title = get_var('page_title', '');
				$password = get_var('password', '');

				if ($admin_page->admin_edit_page_update(true, $page_id, $page_title, $password))
				{
					message_die(GENERAL_MESSAGE, '修改成功！<br />点击 <a href="' . append_sid('admin_pages.php') . '">这里</a> 返回自定义页面列表');
				}
			}
			else
			{
				$admin_page->admin_edit_page_body(true, $page_id);
			}
			
		}
		else
		{
			$per 	= 3;
			$start 	= get_pagination_start($per);
			$admin_page->admin_page_list($start, $per);
		}
		break;
}

require('page_footer_admin.php');
?>