<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !defined('IN_PHPBB') )
{
	exit;
}

class admin_module extends module
{
	/*
	* 页面编辑模式 
	*/
	function show_manage($style_id)
	{
		global $userdata, $template, $db, $board_config;
		
		if ( $userdata['user_new_privmsg'] )
		{
			$l_privmsgs_text 	= '收信箱(' . $userdata['user_new_privmsg'] . ')';
			
			if ( $userdata['user_last_privmsg'] > $userdata['user_lastvisit'] )
			{
				$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_last_privmsg = ' . $userdata['user_lastvisit'] . '
					WHERE user_id = ' . $userdata['user_id'];
					
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not update private message new/read time for user', '', __LINE__, __FILE__, $sql);
				}
			}
		}
		else
		{
			$l_privmsgs_text = '收信箱(0)';
		}
		
		$this->manage_orter_box($style_id, MODULE_TOP);
		$this->manage_box($style_id);
		$this->manage_orter_box($style_id, MODULE_BOTTOM);

		$template->set_filenames(array(
			'body' => 'index_body.tpl')
		);
		
		$template->assign_block_vars('admin_module_header', array());
		$template->assign_block_vars('switch_user_logged_in', array());
		
		$template->assign_vars(array(
			'U_EXIT_ADMIN_MODULE' 	=> append_sid(ROOT_PATH . 'index.php'))
		);
		$template->assign_block_vars('exit_admin_module', array());
		
		$page_desc = '【<a href="' . append_sid('admin_modules.php?mode=desc') . '">修</a>】' . $board_config['site_desc'];
		
		$template->assign_vars(array(
			'PAGE_DESC' 			=> $page_desc,
			'ROOT_PATH' 			=> ROOT_PATH,
			'PRIVATE_MESSAGE_INFO' 	=> $l_privmsgs_text,
			'LOGO'					=> $board_config['site_logo'],
			
			'U_HEAD'				=> append_sid('admin_modules.php?mode=head'),
			'U_FOOT'				=> append_sid('admin_modules.php?mode=foot'),
			'U_LOGO'				=> append_sid('admin_modules.php?mode=logo'),
			
			'U_CREATE_MODULE'		=> append_sid('admin_modules.php?mode=create'),
			'U_PAGE_LIST'			=> append_sid('admin_pages.php'),
			
			'U_LOGOUT'				=> append_sid('login.php?logout=true'),
			'U_PEIVATE'				=> append_sid(ROOT_PATH . 'privmsg.php?folder=inbox'),
			'U_LOGOUT'				=> append_sid(ROOT_PATH . 'login.php?logout=true'),
			'U_UCP'					=> append_sid(ROOT_PATH . 'ucp.php?mode=viewprofile&u=' . $userdata['user_id']))
		);
		
	}
	
	/*
	*页面编辑模式的 BOX 
	*/
	function manage_box($style_id)
	{
		global $db, $template;
		
		$sql = 'SELECT module_id, module_name, module_br, module_type, module_param, module_text
			FROM ' . MODULES_TABLE . '
			WHERE module_type <> ' . MODULE_TOP . ' 
				AND module_type <> ' . MODULE_HEAD . ' 
				AND module_type <> ' . MODULE_BOTTOM . ' 
				AND module_type <> ' . MODULE_FOOT . '
				AND module_style_id = ' . $style_id . '
			ORDER BY module_order ASC';
		
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		$total_module = $db->sql_numrows($result);
		
		while ($module_manage = $db->sql_fetchrow($result))
		{
			$module_name 	= $module_manage['module_name'];
			$module_br 		= ( $module_manage['module_br'] == 1 ) ? '<br />' : '';
			$module_type	= $module_manage['module_type'];
			$module_param 	= $module_manage['module_param'];
			$new_link		= $this->make_link($module_type, $module_name, $module_param, true);
			
			$template->assign_block_vars('module_manage', array(
				'U_MODULE_INSERT'		=> append_sid('admin_modules.php?mode=insert&amp;mid=' . $module_manage['module_id']),
				'U_MODULE_EDIT'			=> append_sid('admin_modules.php?mode=edit&amp;mid=' . $module_manage['module_id']),
				'MODULE_BR'				=> $module_br,
				'MODULE_TEXT'			=> $this->parser_module_bbcode($module_manage['module_text']),
				'MODULE_NAME'			=> $new_link)
			);
		}

		if ( !$total_module )
		{
			$template->assign_block_vars('empty_module_manage', array());
		}
		
		$template->set_filenames(array(
			'module' => 'admin/module_manage_box.tpl')
		);
		
		$template->assign_var_from_handle('MODULE_BOX', 'module');
	}
	
	/*
	* MODULE_TOP 顶部
	* MODULE_HEAD 全局顶部
	* MODULE_BOTTOM 底部
	* MODULE_FOOT 全局底部
	*/
	function manage_orter_box($style_id, $type)
	{
		global $db, $template;
		
		$sql = 'SELECT module_text 
			FROM ' . MODULES_TABLE . ' 
			WHERE module_type = ' . $type . '
				AND module_style_id = ' . $style_id;
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}
	
		$row = $db->sql_fetchrow($result);
		
		
		$template->set_filenames(array(
			'other' => 'module_other_box.tpl')
		);

		switch($type)
		{
			case MODULE_TOP:
				$orter = '【<a href="' . append_sid('admin_modules.php?mode=top') . '">顶</a>】';
				$template->assign_vars(array('MODULE_ORTHER' => $orter . $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_TOP_BOX', 'other');
			break;
			case MODULE_HEAD:
				$orter = '【<a href="' . append_sid('admin_modules.php?mode=head') . '">全局顶部</a>】';
				$template->assign_vars(array('MODULE_ORTHER' => $orter . $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_HEAD_BOX', 'other');
			break;
			case MODULE_BOTTOM:
				$orter = '【<a href="' . append_sid('admin_modules.php?mode=bottom') . '">底</a>】';
				$template->assign_vars(array('MODULE_ORTHER' => $orter . $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_BOTTOM_BOX', 'other');
			break;
			case MODULE_FOOT:
				$orter = '【<a href="' . append_sid('admin_modules.php?mode=foor') . '">全局底部</a>】';
				$template->assign_vars(array('MODULE_ORTHER' => $orter . $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_FOOT_BOX', 'other');
			break;
			default:
				message_die(GENERAL_ERROR, 'MODULE ERROR', '', __LINE__, __FILE__);
		}
		
	}
	
	function other_module($style_id, $type)
	{
		global $template, $db;
		
		$sql = 'SELECT module_text 
			FROM ' . MODULES_TABLE . ' 
			WHERE module_type = ' . $type . '
				AND module_style_id = ' . $style_id;
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		$other_module = $db->sql_fetchrow($result);
		
		switch($type)
		{
			case MODULE_TOP:
				$title = '编辑顶部模块';
				$s_other_action = append_sid('admin_modules.php?mode=top');
			break;
			case MODULE_HEAD:
				$title = '编辑全局顶部模块';
				$s_other_action = append_sid('admin_modules.php?mode=head');
			break;
			case MODULE_BOTTOM:
				$title = '编辑底部模块';
				$s_other_action = append_sid('admin_modules.php?mode=bottom');
			break;
			case MODULE_FOOT:
				$title = '编辑全局底部模块';
				$s_other_action = append_sid('admin_modules.php?mode=foot');
			break;
			default:
				message_die(GENERAL_ERROR, 'MODULE ERROR', '', __LINE__, __FILE__);
		}
		$template->set_filenames(array(
			'body' => 'admin/module_other_body.tpl')
		);
		$template->assign_vars(array(
			'TITLE'				=> $title,
			'S_OTHER_ACTION' 	=> $s_other_action,
			'U_BACK'			=> append_sid('admin_modules.php'),
			'U_UBB_HELP'		=> append_sid('help.php?mode=mbb'),
			'OTHER_MODULE_TEXT'	=> $other_module['module_text']
		));
	}
	
	function update_other_module_data($style_id, $type, $data)
	{
		global $db;
		
		$sql = "SELECT module_id  
			FROM " . MODULES_TABLE . " 
			WHERE module_type = $type
				AND module_style_id = $style_id";

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法查询 module 表！', '', __LINE__, __FILE__, $sql);
		}

		if ($db->sql_numrows($result))
		{
			$sql = 'UPDATE ' . MODULES_TABLE . " 
				SET module_text = '" . $db->sql_escape($data) . "' 
				WHERE module_type = $type
					AND module_style_id = $style_id";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法更新 module 表！', '', __LINE__, __FILE__, $sql);
			}
		}
		else
		{
			$sql = "INSERT INTO " . MODULES_TABLE . " (module_text, module_type, module_style_id) 
				VALUES ('" . $db->sql_escape($data) . "', $type, $style_id)";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法插入数据到 module 表！', '', __LINE__, __FILE__, $sql);
			}
		}
	}
	
	function logo()
	{
		global $template;
		
		$template->set_filenames(array(
			'body' => 'admin/module_logo.tpl')
		);
		
		$template->assign_vars(array(
			'S_UPLOAD_ACTION' 	=> append_sid('admin_modules.php?mode=logo'),
			'U_MODULES'			=> append_sid('admin_modules.php'))
		);
	}
	
	/*
	*【插】的页面
	*/
	function insert_content($module_id)
	{
		global $template, $db;
		
		$module_id = abs(intval($module_id));
		
		$sql = 'SELECT module_name, module_text 
			FROM ' . MODULES_TABLE . ' 
			WHERE module_id = ' . $module_id;
		
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		if ( !$module_row = $db->sql_fetchrow($result) )
		{
			message_die(GENERAL_MESSAGE, '模块不存在');
		}
		
		$template->assign_vars(array(
			'MODULE_NAME' 		=> ($module_row['module_name'] == '') ? '名为空' : $module_row['module_name'],
			'MODULE_TEXT' 		=> $module_row['module_text'],
			'U_MODULE_MANAGE'	=> append_sid('admin_modules.php'),
			'U_UBB_HELP'		=> append_sid('help.php?mode=mbb'),
			'S_INSERT_ACTION'	=> append_sid('admin_modules.php?mode=insert&amp;mid=' . $module_id))
		);
		
		$template->set_filenames(array(
			'body' => 'admin/module_insert.tpl')
		);
	}
	
	/*
	* 往数据库插入 insert 页面提交的数据
	* @参数 整数 $module_id 模块的id
	* @参数 文本 $module_text 模块前的内容 
	* @返回 失败返回 false 成功返回 true 
	*/
	function update_insert_content($module_id, $module_text)
	{
		global $db;
		
		$module_id = abs(intval($module_id));
		
		$sql = "UPDATE " . MODULES_TABLE . " 
			SET module_text = '" . $db->sql_escape($module_text) . "' 
			WHERE module_id = $module_id";
			
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法对 ' . MODULES_TABLE . ' 进行更新', '', __LINE__, __FILE__, $sql);
		}
		
		return true;
	}

	function select($default, $select_name)
	{
		$select = '<select name="' . $select_name . '">';
		$select_array = array(
			MODULE_COMMON		=> '普通模块',
			MODULE_FORUM 		=> '论坛模块',
			MODULE_MODS 		=> 'MODS中心模块',
			MODULE_GROUPCP 		=> '小组模块',
			MODULE_RULES 		=> '规则模块',
			MODULE_SEARCH 		=> '搜索模块',
			MODULE_MEMBERLIST 	=> '会员列表模块',
			MODULE_ADMIN_LIST	=> '管理员列表',
			MODULE_VIEWONLINE 	=> '在线状态模块',
			MODULE_GROUPCP 		=> '小组模块',
			MODULE_LOADING		=> 'MODS模块',
			MODULE_VIEWFORUM	=> '子论坛',
			MODULE_PAGE 		=> '自定义页'
		);
		
		foreach($select_array as $value => $name)
		{
			$selected = ( $value == $default ) ? ' selected="selected"' : '';
			$select .= '<option value="' . $value . '"' . $selected . '>' . $name . '</option>';
		}
		
		$select .= '</select>';
		
		return $select;
	}
	
	function insert_module_data($style_id, $module_id, $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, $up = false)
	{
		global $db;
		
		if ($up)
		{
			$sql = 'SELECT MAX( module_id ) AS new_module_id FROM ' . MODULES_TABLE;
			
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
			}
			
			$row = $db->sql_fetchrow($result);
			if (!$module_id)
			{
				$sql = 'INSERT INTO ' . MODULES_TABLE . ' (module_id, module_name, module_param, module_type, module_br, module_show, module_order, module_style_id)
					VALUES (' . ($row['new_module_id'] + 1)  . ", '" . $db->sql_escape($module_name) . "', '" . $db->sql_escape($module_param) . "', $module_type, $module_br, $module_show, $module_order, $style_id)";
			}
		}
		else
		{
			$sql = 'UPDATE ' . MODULES_TABLE . " 
				SET module_name = '" . $db->sql_escape($module_name) . "', module_param = '" . $db->sql_escape($module_param) . "', module_type = '$module_type', module_br = '$module_br', module_show = '$module_show', module_order = '$module_order'
				WHERE module_id = $module_id";
		}
		
		if ( !$db->sql_query($sql) )
		{
			return false;
		}
		
		return true;
	}
	
	/*
	* 对提交的模块数据进行验证
	*/
	function validate_type($type, $module_param = '', $name = '')
	{
		global $db;
		
		$type = intval($type);
		
		if ($type == MODULE_LOADING)
		{
			if($module_param == '')
			{
				return false;
			}
			
			if (!is_string($module_param) && !preg_match("/^[\w\-\/]+$/", $module_param))
			{
				return false;
			}
			
			$sql = 'SELECT mod_dir 
				FROM ' . MODS_TABLE . " 
				WHERE mod_dir = '" . $db->sql_escape($module_param) . "'";
				
			if ( !$result = $db->sql_query($sql) )
			{
				return false;
			}
			
			if ( !$db->sql_numrows($result) )
			{
				return false;
			}
		}
		else if($type != MODULE_COMMON)
		{
			if( $name == '')
			{
				return false;
			}
		}
		
		return true;
	}
	
	/*
	* 创建编辑模块的框架
	* @参数 布尔值 $type_mode 创建或者修改 默认为true
	*/
	function module($type_mode = true, $module_id = '')
	{
		global $template, $db;
				
		if ( $type_mode )
		{
			$title_name = '编辑模块';
			
			$template->assign_block_vars('switch_admin_module', array());
			
			$module_id = intval($module_id);
			
			$sql = 'SELECT module_id, module_name, module_param, module_type, module_br, module_show, module_order 
				FROM ' . MODULES_TABLE . ' 
				WHERE module_id = ' . $module_id;
				
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
			}
		
			$module = $db->sql_fetchrow($result);

			
			$module_name 	= $module['module_name'];
			$module_param 	= $module['module_param'];
			$module_type 	= $module['module_type'];
			$module_br 		= $module['module_br'];
			$module_show 	= $module['module_show'];
			$module_order 	= $module['module_order'];
			$module_action_url = append_sid('admin_modules.php?mode=edit');
			
			$template->assign_block_vars('delete_module', array());
			$template->assign_vars(array('MODULE_ID' => $module['module_id']));
		}
		else
		{
			$title_name = '创建模块';
			$module_name = '';
			$module_param = '';
			$module_type = '';
			$module_br = '';
			$module_show = '';
			$module_order = '';
			$module_action_url = append_sid('admin_modules.php?mode=create');
		}
		
		
		$template->assign_vars(array(
			'TITLE_NAME' 				=> $title_name,
			'MODULE_NAME'				=> $module_name,
			'MODULE_TYPE'				=> $this->select($module_type, 'type'),
			'MODULE_PARAM'				=> $module_param,
			'MODULE_BR_CHECK'			=> ( $module_br ) ? ' checked="checked"' : '',
			'MODULE_SHOW_CHECK'			=> ( $type_mode ) ? (( $module_show ) ? ' checked="checked"' : '') : ' checked="checked"',
			'MODULE_ORDER'				=> $module_order,
			'S_MODULE_ACTION'			=> $module_action_url)
		);
		
		$template->set_filenames(array(
			'body' => 'admin/module_create.tpl')
		);
	}
	
	function desc_content()
	{
		global $template, $board_config;
		
		$template->assign_vars(array(
			'SITE_DESC' 	=> $board_config['site_desc'],
			'S_DESC_ACTION' => append_sid('admin_modules.php?mode=desc'),
			'U_BACK'		=> append_sid('admin_modules.php'))
		);
		$template->set_filenames(array(
			'body' => 'admin/module_desc.tpl')
		);
	}
	
	function update_desc($desc)
	{
		global $db;
		
		$sql = 'UPDATE ' . CONFIG_TABLE . " 
			SET config_value = '" . $db->sql_escape($desc) . "' 
			WHERE config_name = 'site_desc'";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法更新 ' . CONFIG_TABLE . ' 表失败！', '', __LINE__, __FILE__, $sql);
		}
	}
	
	function delete($module_id)
	{
		global $db;
		
		$sql = 'SELECT module_id 
			FROM ' . MODULES_TABLE . ' 
			WHERE module_id = ' . $module_id;
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 modules 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		if ($db->sql_numrows($result))
		{
			$sql = 'DELETE FROM ' . MODULES_TABLE . ' 
				WHERE module_id = ' . $module_id;
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法删除 modules 表的数据！', '', __LINE__, __FILE__, $sql);
			}
			
			return true;
				
		}
		
		return false;
	}
}

$admin_module = new admin_module;