<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

/**
* 自定义页面后台管理类
*/
class admin_page extends page_module
{
	/*
	* 显示所有的自定义页面
	*/
	function admin_page_list($start, $per)
	{
		global $db, $template;

		$sql = 'SELECT SQL_CALC_FOUND_ROWS page_id, page_title
			FROM ' . PAGES_TABLE . '
			ORDER BY page_id DESC
			LIMIT ' . $start . ', ' . $per;

		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法查询 ' . PAGES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
		}

		if ($db->sql_numrows($result))
		{
			$i = 0;
			while ($row = $db->sql_fetchrow($result))
			{
				$row_class = ( !($i % 2) ) ? 'row1' : 'row2';
				$template->assign_block_vars('page_row', array(
					'ROW_CLASS'		=> $row_class,
					'NUMBER'		=> $i + $start + 1,
					'PAGE_ID' 		=> $row['page_id'],
					'PAGE_TITLE' 	=> $row['page_title'],
					'U_VIEW_PAGE'	=> append_sid(ROOT_PATH . 'page.php?page_id=' . $row['page_id']),
					'U_EDIT_PAGE'	=> append_sid(ROOT_PATH . 'admin/admin_pages.php?action=edit&amp;page_id=' . $row['page_id']),
					'U_PAGE_MANAGE' => append_sid(ROOT_PATH . 'admin/admin_pages.php?mode=manage&page_id=' . $row['page_id']))
				);
				$i++;
			}
		}
		else
		{
			// 没有页面
			$template->assign_block_vars('empty_page', array());
		}

		$template->set_filenames(array(
			'page_list' => 'admin/admin_page_list.tpl')
		);

		$sql = "SELECT found_rows() AS all_page"; 

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法获得统计信息！', '', __LINE__, __FILE__, $sql);
		}

		$row = $db->sql_fetchrow($result);
		
		$total_page = $row['all_page'];

		$pagination = generate_pagination("admin_pages.php?", $total_page, $per, $start);

		$template->assign_vars(array(
			'PAGINATION' 		=> $pagination,
			'U_CREATE_PAGE' 	=> append_sid(ROOT_PATH . 'admin/admin_pages.php?action=create'),
			'U_ADMIN_MODULE' 	=> append_sid(ROOT_PATH . 'admin/admin_modules.php'))
		);

		$template->pparse('page_list');
	}

	/*
	* 编辑自定义页面
	*/
	function admin_edit_page_body($mode = true, $page_id = '')
	{
		global $db, $template;

		if ($mode)
		{
			$sql = 'SELECT page_id, page_title
				FROM ' . PAGES_TABLE . '
				WHERE page_id = ' . $page_id;

			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, '无法查询 ' . PAGES_TABLE . ' 表', 'MYSQL错误', __LINE__, __FILE__, $sql);
			}

			if (!$db->sql_numrows($result))
			{
				message_die(GENERAL_MESSAGE, '页面不存在', '提示');
			}

			$page_row = $db->sql_fetchrow($result);

			$title = '编辑自定义页面';

			$page_id = $page_row['page_id'];

			$page_title = $page_row['page_title'];

			$s_page_action = append_sid(ROOT_PATH . 'admin/admin_pages.php?action=edit&page_id=' .$page_id);

			$template->assign_block_vars('delete_page', array());
		}
		else
		{

			$title = '新建页面';

			$page_id = '无';

			$page_title = '';

			$page_password = '';

			$s_page_action = append_sid(ROOT_PATH . 'admin/admin_pages.php?action=create');
		}

		$template->assign_vars(array(
			'L_TITLE'				=> $title,
			'PAGE_ID'				=> $page_id,
			'PAGE_TITLE' 			=> $page_title,
			'U_ADMIN_MODULE'		=> append_sid(ROOT_PATH . 'admin/admin_modules.php'),
			'S_PAGE_ACTION'			=> $s_page_action)
		);

		$template->set_filenames(array(
			'page_edit' => 'admin/page_edit.tpl')
		);

		$template->pparse('page_edit');

	}

	/*
	* 对编辑自定义页面提交的信息保存到数据库中
	*/
	function admin_edit_page_update($mode = true, $page_id = '', $page_title)
	{
		global $db;

		if ($mode)
		{
			$sql = "UPDATE " . PAGES_TABLE . " 
				SET page_title = '$page_title'
				WHERE page_id = " . $page_id;
		}
		else
		{
			$sql = "INSERT INTO " . PAGES_TABLE . "(page_title) 
				VALUES ('$page_title')";
		}

		if (!$db->sql_query($sql))
		{
			return message_die(GENERAL_ERROR, '无法查询 ' . PAGES_TABLE . ' 表', 'MYSQL错误', __LINE__, __FILE__, $sql);
		}

		return true;
	}

	/*
	* 删除自定义页面
	*/
	function admin_delete_page($page_id)
	{
		global $db;

		$sql = 'DELETE FROM ' . PAGES_TABLE . ' 
			WHERE page_id = ' . $page_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法删除 ' . PAGES_TABLE . ' 表的数据！', 'MYSQL错误', __LINE__, __FILE__, $sql);
		}

		$sql = 'DELETE FROM ' . PAGE_MODULES_TABLE . '
			WHERE module_page_id = ' . $page_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法删除 ' . PAGES_TABLE . ' 表的数据！', 'MYSQL错误', __LINE__, __FILE__, $sql);
		}

		return true;
	}

	/*
	* 管理自定义页面的模块
	*/
	function manage($page_id)
	{
		global $db, $template;

		$sql = 'SELECT module_id, module_name, module_text, module_param, module_type, module_br, module_show, module_order
			FROM ' . PAGE_MODULES_TABLE . '
			WHERE module_page_id = ' . $page_id . '
			ORDER BY module_order ASC';

		if ($result = $db->sql_query($sql))
		{
			if ($db->sql_numrows($result))
			{
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_name 	= $row['module_name'];
					$module_br 		= ( $row['module_br'] == 1 ) ? '<br />' : '';
					$module_type 	= $row['module_type'];
					$module_param 	= $row['module_param'];
					$module_show 	= $row['module_show'];
					
					$new_link = ( $module_show ) ? $this->make_link($module_type, $module_name, $module_param, true) : '';
					
					$template->assign_block_vars('module_row', array(
						'MODULE_BR'				=> $module_br,
						'MODULE_TEXT'			=> $this->parser_module_bbcode($row['module_text']),
						'MODULE_NAME'			=> $new_link,
						'U_MODULE_INSERT'		=> append_sid('admin_pages.php?mode=insert&amp;page_id=' . $page_id . '&amp;mid=' . $row['module_id']),
						'U_MODULE_EDIT'			=> append_sid('admin_pages.php?mode=edit&amp;page_id=' . $page_id . '&amp;mid=' . $row['module_id']))
					);
				}
			}
			else
			{
				$template->assign_block_vars('empty_module', array());
			}

		}
		else
		{
			message_die(GENERAL_ERROR, '无法查询 ' . PAGE_MODULES_TABLE . ' 表', 'MYSQL错误', __LINE__, __FILE__, $sql);
		}

		$template->set_filenames(array(
			'manage' => 'admin/page_manage.tpl')
		);

		$template->assign_vars(array(
			'VIEW_PAGE' 			=> append_sid(ROOT_PATH . 'page.php?page_id=' . $page_id),
			'BACK_ADMIN_MODULE' 	=> append_sid(ROOT_PATH . 'admin/admin_modules.php'),
			'U_ADMIN_MODULE'		=> append_sid(ROOT_PATH . 'admin/admin_modules.php'),
			'U_CREATE_MODULE'		=> append_sid(ROOT_PATH . 'admin/admin_pages.php?mode=create&amp;page_id=' . $page_id),
			'U_PAGE_LIST'			=> append_sid(ROOT_PATH . 'admin/admin_pages.php'))
		);
		$template->pparse('manage');
	}

	/*
	* 自定义页面【插】的功能
	*/
	function insert_content($page_id, $module_id)
	{
		global $db, $template;

		$sql = 'SELECT module_name, module_text
			FROM ' . PAGE_MODULES_TABLE . '
			WHERE module_page_id = ' . $page_id . '
				AND module_id = ' . $module_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 ' . PAGE_MODULES_TABLE . ' 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		if ( !$module_row = $db->sql_fetchrow($result) )
		{
			message_die(GENERAL_MESSAGE, '模块不存在');
		}

		$template->assign_vars(array(
			'MODULE_NAME' 		=> ($module_row['module_name'] == '') ? '名为空' : $module_row['module_name'],
			'MODULE_TEXT' 		=> $module_row['module_text'],
			'U_PAGE_MANAGE'		=> append_sid('admin_pages.php?mode=manage&amp;page_id=' . $page_id),
			'U_UBB_HELP'		=> append_sid('help.php?mode=mbb'),
			'S_INSERT_ACTION'	=> append_sid('admin_pages.php?mode=insert&amp;page_id=' . $page_id . '&amp;mid=' . $module_id))
		);

		$template->set_filenames(array(
			'insert' => 'admin/admin_page_insert.tpl')
		);

		$template->pparse('insert');
	}

	/*
	* 往数据库插入 insert 页面提交的数据
	* @参数 整数 $page_id 页面的ID
	* @参数 整数 $module_id 模块的id
	* @参数 文本 $module_text 模块前的内容 
	* @返回 失败返回 false 成功返回 true 
	*/
	function update_insert_content($page_id, $module_id, $module_text)
	{
		global $db;
		
		$module_id = abs(intval($module_id));
		
		$sql = "UPDATE " . PAGE_MODULES_TABLE . " 
			SET module_text = '" . $db->sql_escape($module_text) . "' 
			WHERE module_page_id = $page_id
				AND module_id = $module_id";
			
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法对 ' . PAGE_MODULES_TABLE . ' 进行更新', '', __LINE__, __FILE__, $sql);
		}
		
		return true;
	}
	
	/*
	* 修改自定义页面的模块类型下拉框
	*/
	function select($default, $select_name)
	{
		$select = '<select name="' . $select_name . '">';
		$select_array = array(
			MODULE_COMMON		=> '普通模块',
			MODULE_FORUM 		=> '论坛模块',
			MODULE_MODS 		=> 'MODS中心模块',
			MODULE_GROUPCP 		=> '小组模块',
			MODULE_RULES 		=> '规则模块',
			MODULE_SEARCH 		=> '搜索模块',
			MODULE_MEMBERLIST 	=> '会员列表模块',
			MODULE_ADMIN_LIST	=> '管理员列表',
			MODULE_VIEWONLINE 	=> '在线状态模块',
			MODULE_GROUPCP 		=> '小组模块',
			MODULE_LOADING		=> 'MODS模块',
			MODULE_VIEWFORUM	=> '子论坛',
			MODULE_PAGE 		=> '自定义页'
		);
		
		foreach($select_array as $value => $name)
		{
			$selected = ( $value == $default ) ? ' selected="selected"' : '';
			$select .= '<option value="' . $value . '"' . $selected . '>' . $name . '</option>';
		}
		
		$select .= '</select>';
		
		return $select;
	}

	/*
	* 创建编辑模块的框架
	* @参数 布尔值 $type_mode 创建或者修改 默认为true
	*/
	function module($page_id, $type_mode = true, $module_id = '')
	{
		global $template, $db;
				
		if ( $type_mode )
		{
			$title_name = '编辑模块';
			
			$template->assign_block_vars('switch_admin_module', array());
			
			$module_id = intval($module_id);
			
			$sql = 'SELECT module_id, module_name, module_param, module_type, module_br, module_show, module_order 
				FROM ' . PAGE_MODULES_TABLE . ' 
				WHERE module_page_id = ' . $page_id . '
					AND module_id = ' . $module_id;
				
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
			}
		
			$module = $db->sql_fetchrow($result);

			
			$module_name 	= $module['module_name'];
			$module_param 	= $module['module_param'];
			$module_type 	= $module['module_type'];
			$module_br 		= $module['module_br'];
			$module_show 	= $module['module_show'];
			$module_order 	= $module['module_order'];
			$module_action_url = append_sid('admin_pages.php?mode=edit&amp;mid=' . $module['module_id'] . '&amp;page_id=' . $page_id);
			
			$template->assign_block_vars('delete_module', array());
			$template->assign_vars(array('MODULE_ID' => $module['module_id']));
		}
		else
		{
			$title_name = '创建模块';
			$module_name = '';
			$module_param = '';
			$module_type = '';
			$module_br = '';
			$module_show = '';
			$module_order = '';
			$module_action_url = append_sid('admin_pages.php?mode=create&amp;page_id=' . $page_id);
		}
		
		
		$template->assign_vars(array(
			'TITLE_NAME' 				=> $title_name,
			'MODULE_NAME'				=> $module_name,
			'MODULE_TYPE'				=> $this->select($module_type, 'type'),
			'MODULE_PARAM'				=> $module_param,
			'MODULE_BR_CHECK'			=> ( $module_br ) ? ' checked="checked"' : '',
			'MODULE_SHOW_CHECK'			=> ( $type_mode ) ? (( $module_show ) ? ' checked="checked"' : '') : ' checked="checked"',
			'MODULE_ORDER'				=> $module_order,
			'S_MODULE_ACTION'			=> $module_action_url)
		);
		
		$template->set_filenames(array(
			'body' => 'admin/admin_page_edit.tpl')
		);

		$template->pparse('body');
	}

	/*
	* 把
	*/
	function insert_module_data($page_id, $module_id, $module_name, $module_param, $module_type, $module_br, $module_show, $module_order, $up = false)
	{
		global $db;
		
		if ($up)
		{
			$sql = 'SELECT MAX( module_id ) AS new_module_id FROM ' . PAGE_MODULES_TABLE;
			
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
			}
			
			$row = $db->sql_fetchrow($result);
			if (!$module_id)
			{
				$sql = 'INSERT INTO ' . PAGE_MODULES_TABLE . ' (module_id, module_name, module_param, module_type, module_br, module_show, module_order, module_page_id)
					VALUES (' . ($row['new_module_id'] + 1)  . ", '" . $db->sql_escape($module_name) . "', '" . $db->sql_escape($module_param) . "', $module_type, $module_br, $module_show, $module_order, $page_id)";
			}
		}
		else
		{
			$sql = 'UPDATE ' . PAGE_MODULES_TABLE . " 
				SET module_name = '" . $db->sql_escape($module_name) . "', module_param = '" . $db->sql_escape($module_param) . "', module_type = '$module_type', module_br = '$module_br', module_show = '$module_show', module_order = '$module_order'
				WHERE module_page_id = $page_id
					AND module_id = $module_id";
		}
		
		if ( !$db->sql_query($sql) )
		{
			return false;
		}
		
		return true;
	}

	/*
	* 对提交的模块数据进行验证
	*/
	function validate_type($type, $module_param = '', $name = '')
	{
		global $db;
		
		$type = intval($type);
		
		if ($type == MODULE_LOADING)
		{
			if($module_param == '')
			{
				return false;
			}
			
			if (!is_string($module_param) && !preg_match("/^[\w\-\/]+$/", $module_param))
			{
				return false;
			}
			
			$sql = 'SELECT mod_dir 
				FROM ' . MODS_TABLE . " 
				WHERE mod_dir = '" . $db->sql_escape($module_param) . "'";
				
			if ( !$result = $db->sql_query($sql) )
			{
				return false;
			}
			
			if ( !$db->sql_numrows($result) )
			{
				return false;
			}
		}
		else if($type != MODULE_COMMON)
		{
			if( $name == '')
			{
				return false;
			}
		}
		
		return true;
	}

	function delete($module_id)
	{
		global $db;
		
		$sql = 'SELECT module_id 
			FROM ' . PAGE_MODULES_TABLE . ' 
			WHERE module_id = ' . $module_id;
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 modules 表失败！', '', __LINE__, __FILE__, $sql);
		}
		
		if ($db->sql_numrows($result))
		{
			$sql = 'DELETE FROM ' . PAGE_MODULES_TABLE . ' 
				WHERE module_id = ' . $module_id;
			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法删除 modules 表的数据！', '', __LINE__, __FILE__, $sql);
			}
			
			return true;
				
		}
		
		return false;
	}

}

?>