<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !defined('IN_PHPBB') )
{
	exit;
}

class module extends module_bbcode
{
	
	function parser_module($style_id)
	{
		global $db, $template;
		
		$sql = 'SELECT module_name, module_br, module_type, module_show, module_param, module_text
			FROM ' . MODULES_TABLE . '
			WHERE module_type <> ' . MODULE_TOP . ' 
				AND module_type <> ' . MODULE_HEAD . ' 
				AND module_type <> ' . MODULE_BOTTOM . ' 
				AND module_type <> ' . MODULE_FOOT . '
				AND module_style_id = ' . $style_id . '
			ORDER BY module_order ASC';
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}

		$total_module = $db->sql_numrows($result);
		
		if ( !$total_module )
		{
			$template->assign_block_vars('empty_module', array());
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$module_name 	= $row['module_name'];
			$module_br 		= ( $row['module_br'] == 1 ) ? '<br />' : '';
			$module_type 	= $row['module_type'];
			$module_param 	= $row['module_param'];
			$module_show 	= $row['module_show'];
			
			$new_link = ( $module_show ) ? $this->make_link($module_type, $module_name, $module_param, false) : '';
			
			$template->assign_block_vars('module_row', array(
				'MODULE_BR'				=> $module_br,
				'MODULE_TEXT'			=> $this->parser_module_bbcode($row['module_text']),
				'MODULE_NAME'			=> $new_link)
			);
		}
		
		$template->set_filenames(array(
			'module' => 'module_box.tpl')
		);
		
		$template->assign_var_from_handle('MODULE_BOX', 'module');
	}
	
	/*
	* 生成各种模块的链接
	* @参数 $link_type 链接的类型
	* @参数 $link_name 链接的名称
	* @参数 $module_param 链接的参数 默认为空
	*/
	function make_link($link_type, $link_name, $module_param = '', $is_admin = false)
	{
		switch($link_type)
		{
			case MODULE_COMMON://普通模块
				$link = $link_name;
				break;	
			case MODULE_FORUM: //论坛中心
				$link = '<a href="' . append_sid(ROOT_PATH . 'forum.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_LOADING:
				$link = '<a href="' . append_sid(ROOT_PATH . 'loading.php?mod=' . $module_param) . '">' . $link_name . '</a>';
				break;
			case MODULE_MODS: //MODS中心
				$link = '<a href="' . append_sid(ROOT_PATH . 'mods.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_GROUPCP: //小组
				$link = '<a href="' . append_sid(ROOT_PATH . 'groupcp.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_RULES: //规则
				$link = '<a href="' . append_sid(ROOT_PATH . 'rules.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_SEARCH: //搜索
				$link = '<a href="' . append_sid(ROOT_PATH . 'search.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_MEMBERLIST: //会员列表
				$link = '<a href="' . append_sid(ROOT_PATH . 'memberlist.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_ADMIN_LIST://管理员列表
				$link = '<a href="' . append_sid(ROOT_PATH . 'memberlist.php?admin') . '">' .$link_name . '</a>';  
				break;
			case MODULE_VIEWONLINE: //在线状态
				$link = '<a href="' . append_sid(ROOT_PATH . 'viewonline.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_VIEWFORUM:
				$link = '<a href="' . append_sid(ROOT_PATH . 'viewforum.php?' . POST_FORUM_URL . '=' . $module_param) . '">' . $link_name . '</a>';
				break;
			case MODULE_PAGE:
				if ($is_admin)
				{
					$link = '<a href="' . append_sid(ROOT_PATH . 'admin/admin_pages.php?mode=manage&amp;page_id=' . $module_param) . '">' . $link_name . '</a>';
				}
				else
				{
					$link = '<a href="' . append_sid(ROOT_PATH . 'page.php?page_id=' . $module_param) . '">' . $link_name . '</a>';
				}
				break;
			default:
				$link = $link_name;	
		}
		
		return $link;
	}

	/*
	* MODULE_TOP 顶部
	* MODULE_HEAD 全局顶部
	* MODULE_BOTTOM 底部
	* MODULE_FOOT 全局底部
	*/
	function parser_other($style_id, $type)
	{
		global $db, $template;
		
		$sql = 'SELECT module_text 
			FROM ' . MODULES_TABLE . ' 
			WHERE module_type = ' . $type . '
				AND module_style_id = ' . $style_id;
			
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '查询 module 表失败！', '', __LINE__, __FILE__, $sql);
		}
	
		$row = $db->sql_fetchrow($result);
	
		$template->set_filenames(array(
			'other' => 'module_other_box.tpl')
		);

		switch($type)
		{
			case MODULE_TOP:
				$template->assign_vars(array('MODULE_ORTHER' => $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_TOP_BOX', 'other');
			break;
			case MODULE_HEAD:
				$template->assign_vars(array('MODULE_ORTHER' => $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_HEAD_BOX', 'other');
			break;
			case MODULE_BOTTOM:
				$template->assign_vars(array('MODULE_ORTHER' => $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_BOTTOM_BOX', 'other');
			break;
			case MODULE_FOOT:
				$template->assign_vars(array('MODULE_ORTHER' => $this->parser_module_bbcode($row['module_text'])));
				$template->assign_var_from_handle('MODULE_FOOT_BOX', 'other');
			break;
			default:
				message_die(GENERAL_ERROR, 'MODULE ERROR', '', __LINE__, __FILE__);
		}
		
	}
}
?>