<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

/**
* 自定义页面
*/
class page_module extends module_bbcode
{

	function main_module($page_id)
	{
		global $db, $template, $userdata;

		$sql = 'SELECT module_name, module_text, module_param, module_type, module_br, module_show, module_order
			FROM ' . PAGE_MODULES_TABLE . '
			WHERE module_page_id = ' . $page_id . '
			ORDER BY module_order ASC';

		if ($result = $db->sql_query($sql))
		{
			if ($db->sql_numrows($result))
			{
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_name 	= $row['module_name'];
					$module_br 		= ( $row['module_br'] == 1 ) ? '<br />' : '';
					$module_type 	= $row['module_type'];
					$module_param 	= $row['module_param'];
					$module_show 	= $row['module_show'];
					
					$new_link = ( $module_show ) ? $this->make_link($module_type, $module_name, $module_param, false) : '';
					
					$template->assign_block_vars('module_row', array(
						'MODULE_BR'				=> $module_br,
						'MODULE_TEXT'			=> $this->parser_module_bbcode($row['module_text']),
						'MODULE_NAME'			=> $new_link)
					);
				}
			}
			else
			{
				$template->assign_block_vars('empty_module', array());
			}

		}
		else
		{
			message_die(GENERAL_ERROR, '无法查询 ' . PAGE_MODULES_TABLE . ' 表', 'MYSQL错误');
		}

		if ( $userdata['user_level'] == ADMIN )
		{
			$template->assign_vars(array(
				'U_ADMIN_PAGE_MODULES' => 'admin/admin_pages.php?mode=manage&page_id=' . $page_id . '&sid=' . $userdata['session_id'])
			);
			$template->assign_block_vars('admin_page_modules', array());
		}

		$template->set_filenames(array(
			'body' => 'pages/show_module.tpl')	
		);

		$template->pparse('body');

	}

	/*
	* 生成各种模块的链接
	* @参数 $link_type 链接的类型
	* @参数 $link_name 链接的名称
	* @参数 $module_param 链接的参数 默认为空
	*/
	function make_link($link_type, $link_name, $module_param = '', $is_admin = false)
	{
		switch($link_type)
		{
			case MODULE_COMMON://普通模块
				$link = $link_name;
				break;	
			case MODULE_FORUM: //论坛中心
				$link = '<a href="' . append_sid(ROOT_PATH . 'forum.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_LOADING:// 加载mods
				$link = '<a href="' . append_sid(ROOT_PATH . 'loading.php?mod=' . $module_param) . '">' . $link_name . '</a>';
				break;
			case MODULE_MODS: //MODS中心
				$link = '<a href="' . append_sid(ROOT_PATH . 'mods.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_GROUPCP: //小组
				$link = '<a href="' . append_sid(ROOT_PATH . 'groupcp.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_RULES: //规则
				$link = '<a href="' . append_sid(ROOT_PATH . 'rules.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_SEARCH: //搜索
				$link = '<a href="' . append_sid(ROOT_PATH . 'search.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_MEMBERLIST: //会员列表
				$link = '<a href="' . append_sid(ROOT_PATH . 'memberlist.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_ADMIN_LIST://管理员列表
				$link = '<a href="' . append_sid(ROOT_PATH . 'memberlist.php?admin') . '">' .$link_name . '</a>';  
				break;
			case MODULE_VIEWONLINE: //在线状态
				$link = '<a href="' . append_sid(ROOT_PATH . 'viewonline.php') . '">' . $link_name . '</a>';
				break;
			case MODULE_VIEWFORUM://加载论坛
				$link = '<a href="' . append_sid(ROOT_PATH . 'viewforum.php?' . POST_FORUM_URL . '=' . $module_param) . '">' . $link_name . '</a>';
				break;
			case MODULE_PAGE:
				if ($is_admin)
				{
					$link = '<a href="' . append_sid(ROOT_PATH . 'admin/admin_pages.php?mode=manage&amp;page_id=' . $module_param) . '">' . $link_name . '</a>';
				}
				else
				{
					$link = '<a href="' . append_sid(ROOT_PATH . 'page.php?page_id=' . $module_param) . '">' . $link_name . '</a>';
				}
				break;
			default:
				$link = $link_name;	
		}
		
		return $link;
	}
}

?>