<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

define('IN_PHPBB', true);
define('ROOT_PATH', './');
require(ROOT_PATH . 'common.php');

$userdata = session_pagestart($user_ip, PAGE_MODS);
init_userprefs($userdata);
	
require(ROOT_PATH . 'includes/functions/mods.php');

if ( isset($_GET['mod']) )
{	
	if ( empty($_GET['mod']) )
	{
		redirect(append_sid('mods.php'));
	}
	else
	{
		$mod = $_GET['mod'];
	}
}
else
{
	redirect(append_sid('mods.php'));
}

// 如果要加载的文件没有使用 $_GET 进行传递，那么将加载mod的默认文件
if ( isset($_GET['load']) )
{
	$load = ( empty($_GET['load']) ) ? $mod : $_GET['load'];
}
else
{
	$load = $mod;
}

if ( is_dir(dirname(__FILE__) . '/mods/' . $mod) )
{
	$sql = "SELECT mod_power  
		FROM " . MODS_TABLE . " 
		WHERE mod_dir = '" . $db->sql_escape($mod) . "'
			AND mod_power = 1";
		
	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, '查询 mods 表失败！', '', __LINE__, __FILE__, $sql);
	}
	
	if ( !$mod_row = $db->sql_fetchrow($result) )
	{
		redirect(append_sid('mods.php'));
	}
	
	if ( !$mod_row['mod_power'] )
	{
		message_die(GENERAL_MESSAGE, '该 MOD 没有开启，如需要使用此 MOD 请联系管理员！');
	}
	
	if( is_string($mod) && preg_match("/^[\w\-\/]+$/", $mod) && file_exists(dirname(__FILE__) . '/mods/' . $mod . '/' . $load . '.php') )
	{
		$filename = $load . '.php';

		// 请不要加载后台文件
		if (mods_adminfile($filename))
		{
			redirect(append_sid('mods.php'));
		}
		
		// 请不要加载安装和卸载文件
		if ($filename == 'install.php' || $filename == 'uninstall.php')
		{
			redirect(append_sid('mods.php'));
		}

		require(ROOT_PATH . 'mods/' . $mod . '/' . $load . '.php');
	}
	else
	{
		redirect(append_sid('mods.php'));
	}
}
else
{
	redirect(append_sid('mods.php'));
}
?>