<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

define('IN_PHPBB', true);
define('ROOT_PATH', './');
require(ROOT_PATH . 'common.php');

// 初始化 $userdata 
$userdata = session_pagestart($user_ip, PAGE_VIEWONLINE);
init_userprefs($userdata);

// 取得分页函数所需的值
$per 	= $board_config['posts_per_page'];
$start 	= get_pagination_start($per);

$page_title = '在线状态';

require(ROOT_PATH . 'includes/page_header.php');

$template->set_filenames(array(
	'body' => 'viewonline_body.tpl')
);

// 获取论坛的信息
$sql = 'SELECT forum_name, forum_id
	FROM ' . FORUMS_TABLE;
if ( $result = $db->sql_query($sql) )
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$forum_data[$row['forum_id']] = $row['forum_name'];
	}
}
else
{
	message_die(GENERAL_ERROR, '无法查询 ' . FORUMS_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
}

$hidden_user_sql = ( $userdata['user_level'] == ADMIN ) ? '' : 'AND u.user_allow_viewonline NOT IN (' . HIDDEN_USER . ')';

// 查询出所有活动的用户
$sql = 'SELECT SQL_CALC_FOUND_ROWS u.user_id, u.username, u.user_nic_color, u.user_allow_viewonline, u.user_level, s.session_logged_in, s.session_time, s.session_page, s.session_ip
	FROM ' . USERS_TABLE . ' u, ' . SESSIONS_TABLE . ' s
	WHERE u.user_id = s.session_user_id
		AND s.session_time >= ' . ( time() - 3600 ) . '
		' . $hidden_user_sql . ' 
	ORDER BY s.session_time DESC
	LIMIT ' . $start . ', ' . $per;
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, '无法获取用户的session信息', '', __LINE__, __FILE__, $sql);
}

$prev_user 			= 0;
$prev_ip 			= '';
$which_counter		= 0;
$view_online 		= false;

while ( $row = $db->sql_fetchrow($result) )
{
	$user_id = $row['user_id'];
	
	// 已登录用户
	if ( $row['session_logged_in'] ) 
	{

		$username = ($row['user_nic_color'] == '') ? $row['username'] : '<span style="color: ' . $row['user_nic_color'] . '">' . $row['username'] . '</span>';

		// 隐身用户
		if ( !$row['user_allow_viewonline'] )
		{
			$view_online 	= ( $userdata['user_level'] == ADMIN ) ? true : false;
			$username 		= '' . $username . ' [隐身]';
		}
		// 在线用户
		else
		{
			$view_online = true;
		}

		$prev_user 		= $user_id;
		
	}
	else
	{
		// 游客
		$username 		= '匿名用户';
		$view_online 	= true;
	}

	$prev_ip = $row['session_ip'];

	if ( $view_online )
	{
		if ( $row['session_page'] < 1 )
		{
			switch( $row['session_page'] )
			{
				case PAGE_INDEX:
					$location = '浏览首页';
					$location_url = 'index.php';
					break;
				case PAGE_POSTING:
					$location = '发表帖子';
					$location_url = 'index.php';
					break;
				case PAGE_LOGIN:
					$location = '登录网站';
					$location_url = 'index.php';
					break;
				case PAGE_SEARCH:
					$location = '搜索网站';
					$location_url = 'search.php';
					break;
				case PAGE_PROFILE:
					$location = '浏览用户中心';
					$location_url = 'index.php';
					break;
				case PAGE_VIEWONLINE:
					$location = '浏览在线状态';
					$location_url = 'viewonline.php';
					break;
				case PAGE_VIEWMEMBERS:
					$location = '浏览用户列表';
					$location_url = 'memberlist.php';
					break;
				case PAGE_PRIVMSGS:
					$location = '浏览信箱';
					$location_url = 'privmsg.php';
					break;
				case PAGE_FAQ:
					$location = '浏览FAQ';
					$location_url = 'faq.php';
					break;
				case PAGE_DOWNLOAD:
					$location = '下载附件';
					$location_url = 'index.php';
					break;
				default:
					$location = '一个无人知晓的地方漫游着';
					$location_url = 'index.php';
			}
		}
		else
		{
			$location_url 	= append_sid('viewforum.php?' . POST_FORUM_URL . '=' . $row['session_page']);
			$location 		= $forum_data[$row['session_page']];
		}
		
		$row_class = ( !($which_counter % 2) ) ? 'row1' : 'row2';
		
		$template->assign_block_vars('online_row', array(
			'ROW_CLASS'			=> $row_class,
			'USERNAME' 			=> $username,
			'LASTUPDATE' 		=> create_date($board_config['default_dateformat'], $row['session_time'], $board_config['board_timezone']),
			'FORUM_LOCATION' 	=> $location,
			'PREV_IP'			=> decode_ip($prev_ip),
			'U_USER_PROFILE' 	=> append_sid('ucp.php?mode=viewprofile&amp;' . POST_USERS_URL . '=' . $user_id),
			'U_FORUM_LOCATION' 	=> append_sid($location_url))
		);
		
		$which_counter++;
	}
}

// 没有用户在线
if ( $which_counter == 0 )
{
	$template->assign_block_vars('not_online_user', array());
}

// 计算出查询的记录总数
$sql = 'SELECT found_rows() AS rowcount'; 

if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, '无法统计在线用户！', '', __LINE__, __FILE__, $sql);
}

$total_online 		= $db->sql_fetchrow($result);
$total_all_online 	= $total_online['rowcount'];

$template->assign_vars(array(
	'TOTAL_ONLINE_USER'				=> $total_all_online, 
	'PAGINATION'					=> generate_pagination('viewonline.php?', $total_all_online, $per, $start))
);

$template->pparse('body');

include(ROOT_PATH . 'includes/page_tail.php');

?>